/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.tables.records.VCoreMissinglistUsageRecord;

import java.util.Collection;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.JSONB;
import org.jooq.Name;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class VCoreMissinglistUsage extends TableImpl<VCoreMissinglistUsageRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.v_core_missinglist_usage</code>
     */
    public static final VCoreMissinglistUsage V_CORE_MISSINGLIST_USAGE = new VCoreMissinglistUsage();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<VCoreMissinglistUsageRecord> getRecordType() {
        return VCoreMissinglistUsageRecord.class;
    }

    /**
     * The column <code>common_dd.v_core_missinglist_usage.pk</code>.
     */
    public final TableField<VCoreMissinglistUsageRecord, Integer> PK = createField(DSL.name("pk"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_core_missinglist_usage.name</code>.
     */
    public final TableField<VCoreMissinglistUsageRecord, String> NAME = createField(DSL.name("name"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_core_missinglist_usage.usages</code>.
     */
    public final TableField<VCoreMissinglistUsageRecord, JSONB> USAGES = createField(DSL.name("usages"), SQLDataType.JSONB, this, "");

    private VCoreMissinglistUsage(Name alias, Table<VCoreMissinglistUsageRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private VCoreMissinglistUsage(Name alias, Table<VCoreMissinglistUsageRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.view("""
        create view "v_core_missinglist_usage" as  SELECT ml.pk,
          ml.name,
          jsonb_agg(e.unique_name) AS usages
         FROM ((common_dd.t_core_missinglist ml
           LEFT JOIN common_dd.t_core_variable v ON ((v.fk_missinglist = ml.pk)))
           LEFT JOIN common_dd.t_core_element_hierarchy e ON ((e.key_element = v.key_variable)))
        WHERE (ml.pk IS NOT NULL)
        GROUP BY ml.pk, ml.name;
        """), where);
    }

    /**
     * Create an aliased <code>common_dd.v_core_missinglist_usage</code> table
     * reference
     */
    public VCoreMissinglistUsage(String alias) {
        this(DSL.name(alias), V_CORE_MISSINGLIST_USAGE);
    }

    /**
     * Create an aliased <code>common_dd.v_core_missinglist_usage</code> table
     * reference
     */
    public VCoreMissinglistUsage(Name alias) {
        this(alias, V_CORE_MISSINGLIST_USAGE);
    }

    /**
     * Create a <code>common_dd.v_core_missinglist_usage</code> table reference
     */
    public VCoreMissinglistUsage() {
        this(DSL.name("v_core_missinglist_usage"), null);
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public VCoreMissinglistUsage as(String alias) {
        return new VCoreMissinglistUsage(DSL.name(alias), this);
    }

    @Override
    public VCoreMissinglistUsage as(Name alias) {
        return new VCoreMissinglistUsage(alias, this);
    }

    @Override
    public VCoreMissinglistUsage as(Table<?> alias) {
        return new VCoreMissinglistUsage(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public VCoreMissinglistUsage rename(String name) {
        return new VCoreMissinglistUsage(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public VCoreMissinglistUsage rename(Name name) {
        return new VCoreMissinglistUsage(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public VCoreMissinglistUsage rename(Table<?> name) {
        return new VCoreMissinglistUsage(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreMissinglistUsage where(Condition condition) {
        return new VCoreMissinglistUsage(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreMissinglistUsage where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreMissinglistUsage where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreMissinglistUsage where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreMissinglistUsage where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreMissinglistUsage where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreMissinglistUsage where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreMissinglistUsage where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreMissinglistUsage whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreMissinglistUsage whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
